/*	$Id: dynload.h 2007/08/21 19:13:52 mallet $ */

/* 
 * Copyright (c) 2000-2007 LAAS/CNRS                  --  Tue May  9 2000
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
#ifndef _DYNLOAD_H
#define _DYNLOAD_H

#ifdef VXWORKS
#include <loadLib.h>
#include <symLib.h>
#include <sysSymTbl.h>
#include <unldLib.h>
#include <errnoLib.h>
#include <unistd.h>
#include <fcntl.h>
#else
#include <dlfcn.h>
#endif

#include "graph.h"

/* Dynamic package handle */
typedef struct InsituPkg {
#ifndef VXWORKS
   void *handle;
#else
   MODULE_ID handle;
#endif
   char *name;
   char *path;

   struct InsituPkg *next;
} InsituPkg;

InsituPkg *	insituLoadPackage(char *path, char *name);
void *		insituGetSymbol(InsituPkg *pkg, char *sym);


#endif /* _DYNLOAD_H */
