/*	$Id: frame.h 2007/08/21 18:18:11 mallet $ */

/* 
 * Copyright (c) 2000-2007 LAAS/CNRS                  --  Wed May 10 2000
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
#ifndef _FRAME_H
#define _FRAME_H

#include "insitu/lib.h"
#include "graph.h"

typedef struct InsituPvFrame {
   int id;
   char name[ISFRM_MAX_LEN];
   InsituPath *path;
   struct InsituPvFrame *next;
} InsituPvFrame;

extern int frameIds;

InsituPvFrame *	insituNewFrame(char *name);
void		insituDeleteFrame(InsituPvFrame *frame);
InsituPvFrame *	insituLookForFrame(char *name, InsituPvFrame *list);
int		insituGetFrameId(InsituPvFrame *frame);
char *		insituGetFrameNameById(InsituPvFrame *list, int id);

#endif /* _FRAME_H */
