WC	[ \t]*
S	[\;\,\{\}\/]
C	[^ \t\n\;\,\{\}\/]*

D	[0-9]
F	([0-9]*\.[0-9]+)|([0-9]+\.)
E	[eE][-+]?[0-9]+

  #include <stdlib.h>
  #include <string.h>
  #include <errno.h>

  #include "insitu.h"
  #include "frame.h"

  #include "geom.h"
  #include "geomparse.h"

  extern int geomLineNumber;

  #define YY_DECL int geomlex(YYSTYPE *geomlval)
  #define Y_VAL(v) geomlval->v.l = geomLineNumber; geomlval->v.v

%option noyywrap nounput

%%

\n		geomLineNumber++;

{WC}		;
{S}		return yytext[0];

-?{F}{E}?	{ Y_VAL(dval) = atof(yytext); return Y_DOUBLE; }
-?{D}+{E}?	{ Y_VAL(dval) = atof(yytext); return Y_DOUBLE; }

require		{ Y_VAL(ival) = Y_REQUIRE; return Y_REQUIRE; }
frame		{ Y_VAL(ival) = Y_FRAME; return Y_FRAME; }
main		{ Y_VAL(ival) = Y_MAIN; return Y_MAIN; }
link		{ Y_VAL(ival) = Y_LINK; return Y_LINK; }

from		{ Y_VAL(ival) = Y_FROM; return Y_FROM; }
to		{ Y_VAL(ival) = Y_TO; return Y_TO; }
translate	{ Y_VAL(ival) = Y_TRANSLATE; return Y_TRANSLATE; }
rotate		{ Y_VAL(ival) = Y_ROTATE; return Y_ROTATE; }
update		{ Y_VAL(ival) = Y_UPDATE; return Y_UPDATE; }

{C}		{
   Y_VAL(sval) = malloc(yyleng+1);
   if (geomlval->sval.sval == NULL) {
      errno = ENOMEM;
      return Y_TOKEN;
   }
   strcpy(geomlval->sval.sval, yytext);
   return Y_TOKEN;
}

^\#.*$ { /* comments */ }

%%

void
geomNewFile(FILE *f, char *file)
{
   extern char geomFileName[];

   yyin = f;
   frameIds = 0;
   YY_NEW_FILE;
   strcpy(geomFileName, file);
   geomLineNumber = 1;
}
